diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc-am-header.cc ns-3.39/src/lte/model/lte-rlc-am-header.cc
--- ns-3.38/src/lte/model/lte-rlc-am-header.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc-am-header.cc	2023-07-05 14:23:48.013428000 -0700
@@ -17,7 +17,7 @@
  * Author: Manuel Requena <manuel.requena@cttc.es>
  */
 
-#include "ns3/lte-rlc-am-header.h"
+#include "lte-rlc-am-header.h"
 
 #include "ns3/log.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc-am-header.h ns-3.39/src/lte/model/lte-rlc-am-header.h
--- ns-3.38/src/lte/model/lte-rlc-am-header.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc-am-header.h	2023-07-05 14:23:48.013428000 -0700
@@ -20,8 +20,9 @@
 #ifndef LTE_RLC_AM_HEADER_H
 #define LTE_RLC_AM_HEADER_H
 
+#include "lte-rlc-sequence-number.h"
+
 #include "ns3/header.h"
-#include "ns3/lte-rlc-sequence-number.h"
 
 #include <list>
 
@@ -73,11 +74,8 @@
         DATA_PDU = 1
     };
 
-    /// ControlPduType_t enumeration
-    enum ControPduType_t
-    {
-        STATUS_PDU = 000,
-    };
+    /// Control PDU type status
+    static constexpr uint8_t STATUS_PDU{0};
 
     //
     // DATA PDU
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc.cc ns-3.39/src/lte/model/lte-rlc.cc
--- ns-3.38/src/lte/model/lte-rlc.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc.cc	2023-07-05 14:23:48.013428000 -0700
@@ -17,16 +17,16 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include "ns3/lte-rlc.h"
+#include "lte-rlc.h"
 
-#include "ns3/log.h"
-#include "ns3/lte-rlc-tag.h"
-#include "ns3/simulator.h"
+#include "lte-rlc-sap.h"
+#include "lte-rlc-tag.h"
 // #include "lte-mac-sap.h"
-#include "ns3/lte-rlc-sap.h"
-
 // #include "ff-mac-sched-sap.h"
 
+#include "ns3/log.h"
+#include "ns3/simulator.h"
+
 namespace ns3
 {
 
@@ -145,6 +145,13 @@
 }
 
 void
+LteRlc::SetPacketDelayBudgetMs(uint16_t packetDelayBudget)
+{
+    NS_LOG_FUNCTION(this << +packetDelayBudget);
+    m_packetDelayBudgetMs = packetDelayBudget;
+}
+
+void
 LteRlc::SetLteRlcSapUser(LteRlcSapUser* s)
 {
     NS_LOG_FUNCTION(this << s);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc.h ns-3.39/src/lte/model/lte-rlc.h
--- ns-3.38/src/lte/model/lte-rlc.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc.h	2023-07-05 14:23:48.013428000 -0700
@@ -20,8 +20,9 @@
 #ifndef LTE_RLC_H
 #define LTE_RLC_H
 
-#include "ns3/lte-mac-sap.h"
-#include "ns3/lte-rlc-sap.h"
+#include "lte-mac-sap.h"
+#include "lte-rlc-sap.h"
+
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 #include "ns3/trace-source-accessor.h"
@@ -76,6 +77,11 @@
     void SetLcId(uint8_t lcId);
 
     /**
+     * \param packetDelayBudget
+     */
+    void SetPacketDelayBudgetMs(uint16_t packetDelayBudget);
+
+    /**
      *
      *
      * \param s the RLC SAP user to be used by this LTE_RLC
@@ -165,6 +171,8 @@
 
     uint16_t m_rnti; ///< RNTI
     uint8_t m_lcid;  ///< LCID
+    uint16_t m_packetDelayBudgetMs{
+        UINT16_MAX}; //!< the packet delay budget in ms of the corresponding logical channel
 
     /**
      * Used to inform of a PDU delivery to the MAC SAP provider
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc-header.cc ns-3.39/src/lte/model/lte-rlc-header.cc
--- ns-3.38/src/lte/model/lte-rlc-header.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc-header.cc	2023-07-05 14:23:48.013428000 -0700
@@ -17,7 +17,7 @@
  * Author: Manuel Requena <manuel.requena@cttc.es>
  */
 
-#include "ns3/lte-rlc-header.h"
+#include "lte-rlc-header.h"
 
 #include "ns3/log.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc-header.h ns-3.39/src/lte/model/lte-rlc-header.h
--- ns-3.38/src/lte/model/lte-rlc-header.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc-header.h	2023-07-05 14:23:48.013428000 -0700
@@ -20,8 +20,9 @@
 #ifndef LTE_RLC_HEADER_H
 #define LTE_RLC_HEADER_H
 
+#include "lte-rlc-sequence-number.h"
+
 #include "ns3/header.h"
-#include "ns3/lte-rlc-sequence-number.h"
 
 #include <list>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc-sap.cc ns-3.39/src/lte/model/lte-rlc-sap.cc
--- ns-3.38/src/lte/model/lte-rlc-sap.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc-sap.cc	2023-07-05 14:23:48.013428000 -0700
@@ -17,7 +17,7 @@
  * Author: Manuel Requena <manuel.requena@cttc.es>
  */
 
-#include "ns3/lte-rlc-sap.h"
+#include "lte-rlc-sap.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc-sdu-status-tag.cc ns-3.39/src/lte/model/lte-rlc-sdu-status-tag.cc
--- ns-3.38/src/lte/model/lte-rlc-sdu-status-tag.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc-sdu-status-tag.cc	2023-07-05 14:23:48.013428000 -0700
@@ -17,7 +17,7 @@
  * Author: Manuel Requena <manuel.requena@cttc.es>
  */
 
-#include "ns3/lte-rlc-sdu-status-tag.h"
+#include "lte-rlc-sdu-status-tag.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc-sequence-number.h ns-3.39/src/lte/model/lte-rlc-sequence-number.h
--- ns-3.38/src/lte/model/lte-rlc-sequence-number.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc-sequence-number.h	2023-07-05 14:23:48.013428000 -0700
@@ -26,8 +26,6 @@
 #include <limits>
 #include <stdint.h>
 
-// #include "ns3/lte-rlc.h"
-
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc-tm.cc ns-3.39/src/lte/model/lte-rlc-tm.cc
--- ns-3.38/src/lte/model/lte-rlc-tm.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc-tm.cc	2023-07-05 14:23:48.013428000 -0700
@@ -18,7 +18,7 @@
  *         Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include "ns3/lte-rlc-tm.h"
+#include "lte-rlc-tm.h"
 
 #include "ns3/log.h"
 #include "ns3/simulator.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc-tm.h ns-3.39/src/lte/model/lte-rlc-tm.h
--- ns-3.38/src/lte/model/lte-rlc-tm.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc-tm.h	2023-07-05 14:23:48.013428000 -0700
@@ -21,7 +21,8 @@
 #ifndef LTE_RLC_TM_H
 #define LTE_RLC_TM_H
 
-#include "ns3/lte-rlc.h"
+#include "lte-rlc.h"
+
 #include <ns3/event-id.h>
 
 #include <map>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc-um.cc ns-3.39/src/lte/model/lte-rlc-um.cc
--- ns-3.38/src/lte/model/lte-rlc-um.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc-um.cc	2023-07-05 14:23:48.013428000 -0700
@@ -17,12 +17,13 @@
  * Author: Manuel Requena <manuel.requena@cttc.es>
  */
 
-#include "ns3/lte-rlc-um.h"
+#include "lte-rlc-um.h"
+
+#include "lte-rlc-header.h"
+#include "lte-rlc-sdu-status-tag.h"
+#include "lte-rlc-tag.h"
 
 #include "ns3/log.h"
-#include "ns3/lte-rlc-header.h"
-#include "ns3/lte-rlc-sdu-status-tag.h"
-#include "ns3/lte-rlc-tag.h"
 #include "ns3/simulator.h"
 
 namespace ns3
@@ -68,7 +69,21 @@
                           "Value of the t-Reordering timer (See section 7.3 of 3GPP TS 36.322)",
                           TimeValue(MilliSeconds(100)),
                           MakeTimeAccessor(&LteRlcUm::m_reorderingTimerValue),
-                          MakeTimeChecker());
+                          MakeTimeChecker())
+            .AddAttribute(
+                "EnablePdcpDiscarding",
+                "Whether to use the PDCP discarding, i.e., perform discarding at the moment "
+                "of passing the PDCP SDU to RLC)",
+                BooleanValue(true),
+                MakeBooleanAccessor(&LteRlcUm::m_enablePdcpDiscarding),
+                MakeBooleanChecker())
+            .AddAttribute("DiscardTimerMs",
+                          "Discard timer in milliseconds to be used to discard packets. "
+                          "If set to 0 then packet delay budget will be used as the discard "
+                          "timer value, otherwise it will be used this value.",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&LteRlcUm::m_discardTimerMs),
+                          MakeUintegerChecker<uint32_t>());
     return tid;
 }
 
@@ -93,6 +108,29 @@
 
     if (m_txBufferSize + p->GetSize() <= m_maxTxBufferSize)
     {
+        if (m_enablePdcpDiscarding)
+        {
+            // discart the packet
+            uint32_t headOfLineDelayInMs = 0;
+            uint32_t discardTimerMs =
+                (m_discardTimerMs > 0) ? m_discardTimerMs : m_packetDelayBudgetMs;
+
+            if (!m_txBuffer.empty())
+            {
+                headOfLineDelayInMs =
+                    (Simulator::Now() - m_txBuffer.begin()->m_waitingSince).GetMilliSeconds();
+            }
+            NS_LOG_DEBUG("head of line delay in MS:" << headOfLineDelayInMs);
+            if (headOfLineDelayInMs > discardTimerMs)
+            {
+                NS_LOG_DEBUG("Tx HOL is higher than this packet can allow. RLC SDU discarded");
+                NS_LOG_DEBUG("headOfLineDelayInMs    = " << headOfLineDelayInMs);
+                NS_LOG_DEBUG("m_packetDelayBudgetMs    = " << m_packetDelayBudgetMs);
+                NS_LOG_DEBUG("packet size     = " << p->GetSize());
+                m_txDropTrace(p);
+            }
+        }
+
         /** Store PDCP PDU */
         LteRlcSduStatusTag tag;
         tag.SetStatus(LteRlcSduStatusTag::FULL_SDU);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rlc-um.h ns-3.39/src/lte/model/lte-rlc-um.h
--- ns-3.38/src/lte/model/lte-rlc-um.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rlc-um.h	2023-07-05 14:23:48.013428000 -0700
@@ -20,8 +20,9 @@
 #ifndef LTE_RLC_UM_H
 #define LTE_RLC_UM_H
 
-#include "ns3/lte-rlc-sequence-number.h"
-#include "ns3/lte-rlc.h"
+#include "lte-rlc-sequence-number.h"
+#include "lte-rlc.h"
+
 #include <ns3/event-id.h>
 
 #include <map>
@@ -143,9 +144,12 @@
     /**
      * Timers. See section 7.3 in TS 36.322
      */
-    Time m_reorderingTimerValue; ///< reordering timer value
-    EventId m_reorderingTimer;   ///< reordering timer
-    EventId m_rbsTimer;          ///< RBS timer
+    Time m_reorderingTimerValue;        ///< reordering timer value
+    EventId m_reorderingTimer;          ///< reordering timer
+    EventId m_rbsTimer;                 ///< RBS timer
+    bool m_enablePdcpDiscarding{false}; //!< whether to use the PDCP discarding (perform discarding
+                                        //!< at the moment of passing the PDCP SDU to RLC)
+    uint32_t m_discardTimerMs{0};       //!< the discard timer value in milliseconds
 
     /**
      * Reassembling state
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rrc-header.cc ns-3.39/src/lte/model/lte-rrc-header.cc
--- ns-3.38/src/lte/model/lte-rrc-header.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rrc-header.cc	2023-07-05 14:23:48.013428000 -0700
@@ -20,7 +20,7 @@
  *          Biljana Bojovic <biljana.bojovic@cttc.es> (Carrier Aggregation)
  */
 
-#include "ns3/lte-rrc-header.h"
+#include "lte-rrc-header.h"
 
 #include "ns3/log.h"
 
@@ -1934,7 +1934,7 @@
         SerializeInteger(rrccsc.ulConfiguration.ulFreqInfo.ulCarrierFreq, 0, MAX_EARFCN);
         SerializeInteger(rrccsc.ulConfiguration.ulFreqInfo.ulBandwidth, 6, 100);
 
-        // Serialize UlPowerControllCommonSCell
+        // Serialize UlPowerControlCommonSCell
         std::bitset<2> UlPowerControlCommonSCell_r10;
         UlPowerControlCommonSCell_r10.set(1, 0); // p0-NominalPUSCH-r10 Not Implemented
         UlPowerControlCommonSCell_r10.set(0, 1); // alpha
@@ -5384,7 +5384,7 @@
         // Serialize t304
         SerializeEnum(8, 0);
 
-        // Serialize newUE-Identitiy
+        // Serialize newUE-Identity
         SerializeBitstring(std::bitset<16>(m_mobilityControlInfo.newUeIdentity));
 
         // Serialize radioResourceConfigCommon
@@ -6258,7 +6258,7 @@
 
     SerializeUlCcchMessage(0);
 
-    // Serialize RrcConnectionReestablishmentReques sequence:
+    // Serialize RrcConnectionReestablishmentRequest sequence:
     // no default or optional fields. Extension marker not present.
     SerializeSequence(std::bitset<0>(), false);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rrc-header.h ns-3.39/src/lte/model/lte-rrc-header.h
--- ns-3.38/src/lte/model/lte-rrc-header.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rrc-header.h	2023-07-05 14:23:48.013428000 -0700
@@ -23,9 +23,10 @@
 #ifndef RRC_HEADER_H
 #define RRC_HEADER_H
 
+#include "lte-asn1-header.h"
+#include "lte-rrc-sap.h"
+
 #include "ns3/header.h"
-#include "ns3/lte-asn1-header.h"
-#include "ns3/lte-rrc-sap.h"
 
 #include <bitset>
 #include <string>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rrc-protocol-ideal.h ns-3.39/src/lte/model/lte-rrc-protocol-ideal.h
--- ns-3.38/src/lte/model/lte-rrc-protocol-ideal.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rrc-protocol-ideal.h	2023-07-05 14:23:48.013428000 -0700
@@ -20,7 +20,8 @@
 #ifndef LTE_RRC_PROTOCOL_IDEAL_H
 #define LTE_RRC_PROTOCOL_IDEAL_H
 
-#include <ns3/lte-rrc-sap.h>
+#include "lte-rrc-sap.h"
+
 #include <ns3/object.h>
 #include <ns3/ptr.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rrc-protocol-real.cc ns-3.39/src/lte/model/lte-rrc-protocol-real.cc
--- ns-3.38/src/lte/model/lte-rrc-protocol-real.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rrc-protocol-real.cc	2023-07-05 14:23:48.013428000 -0700
@@ -22,6 +22,7 @@
 
 #include "lte-enb-net-device.h"
 #include "lte-enb-rrc.h"
+#include "lte-rrc-header.h"
 #include "lte-ue-net-device.h"
 #include "lte-ue-rrc.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-rrc-protocol-real.h ns-3.39/src/lte/model/lte-rrc-protocol-real.h
--- ns-3.38/src/lte/model/lte-rrc-protocol-real.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-rrc-protocol-real.h	2023-07-05 14:23:48.013428000 -0700
@@ -21,10 +21,10 @@
 #ifndef LTE_RRC_PROTOCOL_REAL_H
 #define LTE_RRC_PROTOCOL_REAL_H
 
-#include <ns3/lte-pdcp-sap.h>
-#include <ns3/lte-rlc-sap.h>
-#include <ns3/lte-rrc-header.h>
-#include <ns3/lte-rrc-sap.h>
+#include "lte-pdcp-sap.h"
+#include "lte-rlc-sap.h"
+#include "lte-rrc-sap.h"
+
 #include <ns3/object.h>
 #include <ns3/ptr.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-spectrum-phy.cc ns-3.39/src/lte/model/lte-spectrum-phy.cc
--- ns-3.38/src/lte/model/lte-spectrum-phy.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-spectrum-phy.cc	2023-07-05 14:23:48.013428000 -0700
@@ -22,8 +22,8 @@
 #include "lte-spectrum-phy.h"
 
 #include "lte-chunk-processor.h"
-#include "lte-net-device.h"
-#include "lte-phy-tag.h"
+#include "lte-control-messages.h"
+#include "lte-mi-error-model.h"
 #include "lte-radio-bearer-tag.h"
 #include "lte-spectrum-signal-parameters.h"
 
@@ -32,8 +32,6 @@
 #include <ns3/config.h>
 #include <ns3/double.h>
 #include <ns3/log.h>
-#include <ns3/lte-mi-error-model.h>
-#include <ns3/lte-radio-bearer-tag.h>
 #include <ns3/object-factory.h>
 #include <ns3/simulator.h>
 #include <ns3/trace-source-accessor.h>
@@ -458,12 +456,10 @@
         m_endTxEvent = Simulator::Schedule(duration, &LteSpectrumPhy::EndTxData, this);
     }
         return false;
-        break;
 
     default:
         NS_FATAL_ERROR("unknown state");
         return true;
-        break;
     }
 }
 
@@ -516,12 +512,10 @@
         m_endTxEvent = Simulator::Schedule(DL_CTRL_DURATION, &LteSpectrumPhy::EndTxDlCtrl, this);
     }
         return false;
-        break;
 
     default:
         NS_FATAL_ERROR("unknown state");
         return true;
-        break;
     }
 }
 
@@ -572,12 +566,10 @@
         m_endTxEvent = Simulator::Schedule(UL_SRS_DURATION, &LteSpectrumPhy::EndTxUlSrs, this);
     }
         return false;
-        break;
 
     default:
         NS_FATAL_ERROR("unknown state");
         return true;
-        break;
     }
 }
 
@@ -764,7 +756,7 @@
 
         // common code for the two states
         // check presence of PSS for UE measuerements
-        if (lteDlCtrlRxParams->pss == true)
+        if (lteDlCtrlRxParams->pss)
         {
             if (!m_ltePhyRxPssCallback.IsNull())
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-spectrum-phy.h ns-3.39/src/lte/model/lte-spectrum-phy.h
--- ns-3.38/src/lte/model/lte-spectrum-phy.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-spectrum-phy.h	2023-07-05 14:23:48.013428000 -0700
@@ -22,19 +22,20 @@
 #ifndef LTE_SPECTRUM_PHY_H
 #define LTE_SPECTRUM_PHY_H
 
-#include "ns3/random-variable-stream.h"
+#include "ff-mac-common.h"
+#include "lte-common.h"
+#include "lte-harq-phy.h"
+#include "lte-interference.h"
+
 #include <ns3/data-rate.h>
 #include <ns3/event-id.h>
-#include <ns3/ff-mac-common.h>
 #include <ns3/generic-phy.h>
-#include <ns3/lte-common.h>
-#include <ns3/lte-harq-phy.h>
-#include <ns3/lte-interference.h>
 #include <ns3/mobility-model.h>
 #include <ns3/net-device.h>
 #include <ns3/nstime.h>
 #include <ns3/packet-burst.h>
 #include <ns3/packet.h>
+#include <ns3/random-variable-stream.h>
 #include <ns3/spectrum-channel.h>
 #include <ns3/spectrum-interference.h>
 #include <ns3/spectrum-phy.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-spectrum-signal-parameters.cc ns-3.39/src/lte/model/lte-spectrum-signal-parameters.cc
--- ns-3.38/src/lte/model/lte-spectrum-signal-parameters.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-spectrum-signal-parameters.cc	2023-07-05 14:23:48.013428000 -0700
@@ -18,9 +18,11 @@
  * Modified by Marco Miozzo <mmiozzo@cttc.es> (add data and ctrl diversity)
  */
 
+#include "lte-spectrum-signal-parameters.h"
+
+#include "lte-control-messages.h"
+
 #include <ns3/log.h>
-#include <ns3/lte-control-messages.h>
-#include <ns3/lte-spectrum-signal-parameters.h>
 #include <ns3/packet-burst.h>
 #include <ns3/ptr.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-spectrum-signal-parameters.h ns-3.39/src/lte/model/lte-spectrum-signal-parameters.h
--- ns-3.38/src/lte/model/lte-spectrum-signal-parameters.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-spectrum-signal-parameters.h	2023-07-05 14:23:48.013428000 -0700
@@ -23,6 +23,8 @@
 
 #include <ns3/spectrum-signal-parameters.h>
 
+#include <list>
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-ccm-rrc-sap.h ns-3.39/src/lte/model/lte-ue-ccm-rrc-sap.h
--- ns-3.38/src/lte/model/lte-ue-ccm-rrc-sap.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-ccm-rrc-sap.h	2023-07-05 14:23:48.017428200 -0700
@@ -21,10 +21,8 @@
 #ifndef LTE_UE_CCM_RRC_SAP_H
 #define LTE_UE_CCM_RRC_SAP_H
 
-#include <ns3/eps-bearer.h>
-#include <ns3/lte-mac-sap.h>
-#include <ns3/lte-rrc-sap.h>
-#include <ns3/lte-ue-cmac-sap.h>
+#include "lte-mac-sap.h"
+#include "lte-ue-cmac-sap.h"
 
 #include <map>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-cmac-sap.h ns-3.39/src/lte/model/lte-ue-cmac-sap.h
--- ns-3.38/src/lte/model/lte-ue-cmac-sap.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-cmac-sap.h	2023-07-05 14:23:48.017428200 -0700
@@ -20,9 +20,6 @@
 #ifndef LTE_UE_CMAC_SAP_H
 #define LTE_UE_CMAC_SAP_H
 
-#include <ns3/eps-bearer.h>
-#include <ns3/ff-mac-common.h>
-#include <ns3/lte-common.h>
 #include <ns3/packet.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-component-carrier-manager.cc ns-3.39/src/lte/model/lte-ue-component-carrier-manager.cc
--- ns-3.38/src/lte/model/lte-ue-component-carrier-manager.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-component-carrier-manager.cc	2023-07-05 14:23:48.017428200 -0700
@@ -20,6 +20,8 @@
 
 #include "lte-ue-component-carrier-manager.h"
 
+#include "lte-common.h"
+
 #include <ns3/log.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-component-carrier-manager.h ns-3.39/src/lte/model/lte-ue-component-carrier-manager.h
--- ns-3.38/src/lte/model/lte-ue-component-carrier-manager.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-component-carrier-manager.h	2023-07-05 14:23:48.017428200 -0700
@@ -21,17 +21,14 @@
 #ifndef LTE_UE_COMPONENT_CARRIER_MANAGER_H
 #define LTE_UE_COMPONENT_CARRIER_MANAGER_H
 
-#include <ns3/lte-mac-sap.h>
-#include <ns3/lte-rrc-sap.h>
-#include <ns3/lte-ue-ccm-rrc-sap.h>
+#include "lte-mac-sap.h"
+#include "lte-ue-ccm-rrc-sap.h"
+
 #include <ns3/object.h>
 
 #include <map>
 #include <vector>
 
-#define MIN_NO_CC 1
-#define MAX_NO_CC 5 // this is the maximum number of carrier components allowed by 3GPP up to R13
-
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-cphy-sap.cc ns-3.39/src/lte/model/lte-ue-cphy-sap.cc
--- ns-3.38/src/lte/model/lte-ue-cphy-sap.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-cphy-sap.cc	2023-07-05 14:23:48.017428200 -0700
@@ -17,7 +17,7 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include "ns3/lte-ue-cphy-sap.h"
+#include "lte-ue-cphy-sap.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-cphy-sap.h ns-3.39/src/lte/model/lte-ue-cphy-sap.h
--- ns-3.38/src/lte/model/lte-ue-cphy-sap.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-cphy-sap.h	2023-07-05 14:23:48.017428200 -0700
@@ -21,7 +21,8 @@
 #ifndef LTE_UE_CPHY_SAP_H
 #define LTE_UE_CPHY_SAP_H
 
-#include <ns3/lte-rrc-sap.h>
+#include "lte-rrc-sap.h"
+
 #include <ns3/ptr.h>
 
 #include <stdint.h>
@@ -194,7 +195,7 @@
      * started by checking if the radio frames are in-sync for N311
      * consecutive times.
      */
-    virtual void StartInSnycDetection() = 0;
+    virtual void StartInSyncDetection() = 0;
 
     /**
      * \brief A method call by UE RRC to communicate the IMSI to the UE PHY
@@ -231,8 +232,8 @@
     /// UeMeasurementsParameters structure
     struct UeMeasurementsParameters
     {
-        std::vector<struct UeMeasurementsElement> m_ueMeasurementsList; ///< UE measurement list
-        uint8_t m_componentCarrierId;                                   ///< component carrier ID
+        std::vector<UeMeasurementsElement> m_ueMeasurementsList; ///< UE measurement list
+        uint8_t m_componentCarrierId;                            ///< component carrier ID
     };
 
     /**
@@ -327,7 +328,7 @@
     void SetRsrpFilterCoefficient(uint8_t rsrpFilterCoefficient) override;
     void ResetPhyAfterRlf() override;
     void ResetRlfParams() override;
-    void StartInSnycDetection() override;
+    void StartInSyncDetection() override;
     void SetImsi(uint64_t imsi) override;
 
   private:
@@ -454,9 +455,9 @@
 
 template <class C>
 void
-MemberLteUeCphySapProvider<C>::StartInSnycDetection()
+MemberLteUeCphySapProvider<C>::StartInSyncDetection()
 {
-    m_owner->DoStartInSnycDetection();
+    m_owner->DoStartInSyncDetection();
 }
 
 template <class C>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-mac.cc ns-3.39/src/lte/model/lte-ue-mac.cc
--- ns-3.38/src/lte/model/lte-ue-mac.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-mac.cc	2023-07-05 14:23:48.017428200 -0700
@@ -20,13 +20,12 @@
 
 #include "lte-ue-mac.h"
 
+#include "ff-mac-common.h"
+#include "lte-common.h"
+#include "lte-control-messages.h"
 #include "lte-radio-bearer-tag.h"
-#include "lte-ue-net-device.h"
 
-#include <ns3/ff-mac-common.h>
 #include <ns3/log.h>
-#include <ns3/lte-common.h>
-#include <ns3/lte-control-messages.h>
 #include <ns3/packet-burst.h>
 #include <ns3/packet.h>
 #include <ns3/pointer.h>
@@ -921,7 +920,7 @@
     m_frameNo = frameNo;
     m_subframeNo = subframeNo;
     RefreshHarqProcessesPacketBuffer();
-    if ((Simulator::Now() >= m_bsrLast + m_bsrPeriodicity) && (m_freshUlBsr == true))
+    if ((Simulator::Now() >= m_bsrLast + m_bsrPeriodicity) && m_freshUlBsr)
     {
         if (m_componentCarrierId == 0)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-mac.h ns-3.39/src/lte/model/lte-ue-mac.h
--- ns-3.38/src/lte/model/lte-ue-mac.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-mac.h	2023-07-05 14:23:48.017428200 -0700
@@ -21,10 +21,12 @@
 #ifndef LTE_UE_MAC_ENTITY_H
 #define LTE_UE_MAC_ENTITY_H
 
+#include "ff-mac-common.h"
+#include "lte-mac-sap.h"
+#include "lte-ue-cmac-sap.h"
+#include "lte-ue-phy-sap.h"
+
 #include <ns3/event-id.h>
-#include <ns3/lte-mac-sap.h>
-#include <ns3/lte-ue-cmac-sap.h>
-#include <ns3/lte-ue-phy-sap.h>
 #include <ns3/nstime.h>
 #include <ns3/packet-burst.h>
 #include <ns3/packet.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-net-device.cc ns-3.39/src/lte/model/lte-ue-net-device.cc
--- ns-3.38/src/lte/model/lte-ue-net-device.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-net-device.cc	2023-07-05 14:23:48.017428200 -0700
@@ -24,10 +24,10 @@
 
 #include "lte-ue-net-device.h"
 
-#include "epc-tft.h"
 #include "epc-ue-nas.h"
-#include "lte-amc.h"
+#include "lte-enb-net-device.h"
 #include "lte-net-device.h"
+#include "lte-ue-component-carrier-manager.h"
 #include "lte-ue-mac.h"
 #include "lte-ue-phy.h"
 #include "lte-ue-rrc.h"
@@ -39,7 +39,6 @@
 #include "ns3/ipv6-header.h"
 #include "ns3/ipv6.h"
 #include "ns3/llc-snap-header.h"
-#include "ns3/lte-enb-net-device.h"
 #include "ns3/node.h"
 #include "ns3/packet-burst.h"
 #include "ns3/packet.h"
@@ -50,7 +49,6 @@
 #include <ns3/ipv4-l3-protocol.h>
 #include <ns3/ipv6-l3-protocol.h>
 #include <ns3/log.h>
-#include <ns3/lte-ue-component-carrier-manager.h>
 #include <ns3/object-factory.h>
 #include <ns3/object-map.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-net-device.h ns-3.39/src/lte/model/lte-ue-net-device.h
--- ns-3.38/src/lte/model/lte-ue-net-device.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-net-device.h	2023-07-05 14:23:48.017428200 -0700
@@ -24,11 +24,10 @@
 #ifndef LTE_UE_NET_DEVICE_H
 #define LTE_UE_NET_DEVICE_H
 
-#include "ns3/component-carrier-ue.h"
-#include "ns3/eps-bearer.h"
+#include "component-carrier-ue.h"
+#include "lte-net-device.h"
+
 #include "ns3/event-id.h"
-#include "ns3/lte-net-device.h"
-#include "ns3/lte-phy.h"
 #include "ns3/nstime.h"
 #include "ns3/traced-callback.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-phy.cc ns-3.39/src/lte/model/lte-ue-phy.cc
--- ns-3.38/src/lte/model/lte-ue-phy.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-phy.cc	2023-07-05 14:23:48.017428200 -0700
@@ -26,19 +26,15 @@
 
 #include "ff-mac-common.h"
 #include "lte-amc.h"
-#include "lte-chunk-processor.h"
-#include "lte-enb-net-device.h"
-#include "lte-enb-phy.h"
+#include "lte-common.h"
 #include "lte-net-device.h"
 #include "lte-spectrum-value-helper.h"
-#include "lte-ue-mac.h"
 #include "lte-ue-net-device.h"
+#include "lte-ue-power-control.h"
 
 #include <ns3/boolean.h>
 #include <ns3/double.h>
 #include <ns3/log.h>
-#include <ns3/lte-common.h>
-#include <ns3/lte-ue-power-control.h>
 #include <ns3/node.h>
 #include <ns3/object-factory.h>
 #include <ns3/pointer.h>
@@ -1585,7 +1581,7 @@
 }
 
 void
-LteUePhy::DoStartInSnycDetection()
+LteUePhy::DoStartInSyncDetection()
 {
     NS_LOG_FUNCTION(this);
     // indicates that the downlink radio link quality has to be monitored for in-sync indications
@@ -1617,7 +1613,7 @@
     m_numOfSubframes++;
     NS_LOG_LOGIC("No of Subframes: " << m_numOfSubframes
                                      << " UE synchronized: " << m_downlinkInSync);
-    // check for out_of_snyc indications first when UE is both DL and UL synchronized
+    // check for out_of_sync indications first when UE is both DL and UL synchronized
     // m_downlinkInSync=true indicates that the evaluation is for out-of-sync indications
     if (m_downlinkInSync && m_numOfSubframes == 10)
     {
@@ -1657,7 +1653,7 @@
         m_ueCphySapUser->NotifyOutOfSync();
         m_numOfFrames = 0;
     }
-    // check for in_snyc indications when T310 timer is started
+    // check for in_sync indications when T310 timer is started
     // m_downlinkInSync=false indicates that the evaluation is for in-sync indications
     if (!m_downlinkInSync && m_numOfSubframes == 10)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-phy.h ns-3.39/src/lte/model/lte-ue-phy.h
--- ns-3.38/src/lte/model/lte-ue-phy.h	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-phy.h	2023-07-05 14:23:48.017428200 -0700
@@ -24,13 +24,14 @@
 #ifndef LTE_UE_PHY_H
 #define LTE_UE_PHY_H
 
-#include <ns3/ff-mac-common.h>
-#include <ns3/lte-amc.h>
-#include <ns3/lte-control-messages.h>
-#include <ns3/lte-phy.h>
-#include <ns3/lte-ue-cphy-sap.h>
-#include <ns3/lte-ue-phy-sap.h>
-#include <ns3/lte-ue-power-control.h>
+#include "ff-mac-common.h"
+#include "lte-amc.h"
+#include "lte-control-messages.h"
+#include "lte-phy.h"
+#include "lte-ue-cphy-sap.h"
+#include "lte-ue-phy-sap.h"
+#include "lte-ue-power-control.h"
+
 #include <ns3/ptr.h>
 
 #include <set>
@@ -580,7 +581,7 @@
      * consecutive times.
      *
      */
-    void DoStartInSnycDetection();
+    void DoStartInSyncDetection();
 
     /**
      * \brief Radio link failure detection function
